import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 *  ϴ Player  Ŭ
 * 
 * @author  
 * @version 0.9
 */
public class Player  extends CanBeCollided
{
    private int power=50;
    private int score;
    private boolean allow;
    private boolean init;
    private int oldPower;
    private int oldRotation;
    
    private ScoreBoard scoreboard;
    private Arrow arrow;
    private Space space;
    
    /**
     * x, y ް, Playerü Ѵ.
     */
    public Player(double x, double y){
        this.x=x;
        this.y=y;
        this.radius=20;
        setRotation(Greenfoot.getRandomNumber(360));
        scoreboard=new ScoreBoard();
        init=true;
    }
    
    public void act() 
    {
        if(init){
            getWorld().addObject(scoreboard,(int)x,(int)y+30);
            init=false;
        }
        scoreboard.updateScore(score);
        if(allow){
            if(Greenfoot.isKeyDown("left")){
                setRotation(getRotation()-1);
            }
            if(Greenfoot.isKeyDown("right")){
                setRotation(getRotation()+1);
            }
            if(Greenfoot.isKeyDown("up")){
                if(power<100){
                    ++power;
                }
            }
            if(Greenfoot.isKeyDown("down")){
                if(power>1){
                    --power;
                }
            }
            if(Greenfoot.isKeyDown("space"));
            if(Greenfoot.isKeyDown("space")){
                fire();
                allow=false;
                space.removeObject(arrow);
            }
            arrow.updateImage(getRotation(),power);
        }
        checkCollision();
    }
    
    /**
     * Bullet   ü Ű Է¹޾ ̿   Ų.
     */
    public void changeScore(CanBeCollided object){
        if(object==this){
            score-=100;
        }
        else if(object instanceof Player){
            score+=110-power;
        }
        else if(object instanceof Planet){
            score+=Greenfoot.getRandomNumber(15)+10;
        }
    }
       
    /**
     * Player ߽Ų. isIn false ٲٰ, image ش.
     */
    public void explosion(){
        isIn=false;
        setImage(new GreenfootImage("dummy.png"));
    }
    
    /**
     * Bullet Player power rotation Ͽ Ѵ.
     */
    private void fire(){
        oldPower=power;
        oldRotation=getRotation();
        ((Space)getWorld()).makeBullet(x+Math.cos(Math.toRadians(getRotation()))*(radius+1),
                                       y+Math.sin(Math.toRadians(getRotation()))*(radius+1),
                                       power,getRotation(),this);
    }
    
    public void reShot(){
        power=oldPower;
        setRotation(oldRotation);
        fire();
    }
    
    /**
     * score ȯѴ.
     */
    public int getScore(){
        return score;
    }
    
    /**
     * allow ȯѴ.(  Player  ȯѴ.)
     */
    private boolean getAllow(){
        return this.allow;
    }
    
    /**
     * power ȯѴ.
     */
    public int getPower(){
        return power;
    }
    
    /**
     * Player allow true .( ȰȭŲ.)
     * Arrow ǥѴ.
     */
    public void setAllow(){
        this.allow=true;
        arrow=new Arrow();
        space=(Space)getWorld();
        space.addObject(arrow,(int)x,(int)y);
    }
}