import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Player  ְ,  ϴ Ŭ
 * 
 * @author  
 * @version 0.9
 */
public class Selector  extends Actor
{
    final int TIME_DELAY=80;
    
    private int curPlayer;
    private int time;
    private int playerN;
    private boolean playerChange;
    private boolean init=true;
    
    private Player[] player;
    GreenfootImage image;
    
    /**
     * Player迭   Է¹޾ ʱȭŰ, Selector Ѵ.
     */
    public Selector(Player[] player,int playerN){
        this.player=player;
        player[0].setAllow();
        curPlayer=0;
        this.playerN=playerN;
        image=new GreenfootImage(400,20);
        image.setColor(Color.BLACK);
        image.fillRect(0,0,400,20);
        image.setTransparency(128);
        setImage(image);
    }
    
    public void act() 
    {
        if(init){
            Greenfoot.playSound("bgm.mp3");
            init=false;
        }
        
        updateStatus();
        if(playerChange&&((Space)getWorld()).getReplay()==true){
            time++;
            if(time>=TIME_DELAY){
                time=0;
                playerChange=false;
                changePlayer();
            }
        }
    }    
    
    /**
     *  Player, Score, Power, Rotation, ð ŽŲ.
     */
    private void updateStatus(){
        int time;
        
        image=new GreenfootImage(400,20);
        image.setColor(Color.RED);
        image.fillRect(0,0,70,20);
        image.setColor(Color.WHITE);
        image.drawString("Player"+(curPlayer+1),10,15);
        image.setColor(Color.WHITE);
        image.fillRect(70,0,90,20);
        image.setColor(Color.RED);
        image.drawString("Score : "+player[curPlayer].getScore(),80,15);
        image.setColor(Color.YELLOW);
        image.fillRect(160,0,90,20);
        image.setColor(Color.BLACK);
        image.drawString("Power : "+player[curPlayer].getPower(),170,15);
        image.setColor(Color.BLACK);
        image.fillRect(250,0,110,20);
        image.setColor(Color.YELLOW);
        image.drawString("Rotation : "+(player[curPlayer].getRotation()+360)%360,260,15);
        
        Bullet bullet=((Space)getWorld()).getBullet();
        if(bullet==null || bullet.getTimeLeft()==0){
            time=Bullet.LIMITTIME;
        }
        else{
            time=bullet.getTimeLeft();
        }
        image.setColor(Color.BLUE);
        image.fillRect(360,0,40,20);
        image.setColor(Color.WHITE);
        image.drawString(time+" ",370,15);
        image.setTransparency(128);
        setImage(image);
    }
    
    /**
     * Player üϵ playerChange true Ѵ.
     */
    public void letNextPlayer(){
        playerChange=true;
    }
    
    /**
     * Player  Player ٲ۴.
     */
    private void changePlayer(){
        do{
            ++curPlayer;
            if(curPlayer==((Space)getWorld()).getPlayerN()) curPlayer=0;
        }while(player[curPlayer].isIn==false);
        
        player[curPlayer].setAllow();
        if(playerN==1){
            int max=0,maxi=0;
            for(int i=0;i<((Space)getWorld()).getPlayerN();i++){
                if(player[i].getScore()>=max){
                    max=player[i].getScore();
                    maxi=i;
                }
            }
            ((Space)getWorld()).finished(maxi);
        }
    }
    
    /**
     * Player ҽŲ.
     */
    public void decreasePlayerN(){
        --playerN;
        if(playerN<1) playerN=1;
    }
    
    /**
     * Player迭 ȯѴ.
     */
    public Player[] getPlayer(){
        return player;
    }
}
